#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "game.h"
#include "settings.h"

Preferences prefscopy;

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 	gtk_main_quit();
}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        int i = 1;
        GtkWidget*prop = create_properties();
        gnome_dialog_set_parent(GNOME_DIALOG(prop),GTK_WINDOW(app));

        memcpy(&prefscopy,&prefs,sizeof prefs);
        /*
         * fill the dialog with values
         */
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"left1")),
                           gdk_keyval_name(prefs.keys[KEY_LEFT0]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"right1")),
                           gdk_keyval_name(prefs.keys[KEY_RIGHT0]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"rotup1")),
                           gdk_keyval_name(prefs.keys[KEY_UP0]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"rotdown1")),
                           gdk_keyval_name(prefs.keys[KEY_DOWN0]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"down1")),
                           gdk_keyval_name(prefs.keys[KEY_FALL0]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"left2")),
                           gdk_keyval_name(prefs.keys[KEY_LEFT1]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"right2")),
                           gdk_keyval_name(prefs.keys[KEY_RIGHT1]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"rotup2")),
                           gdk_keyval_name(prefs.keys[KEY_UP1]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"rotdown2")),
                           gdk_keyval_name(prefs.keys[KEY_DOWN1]));
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"down2")),
                           gdk_keyval_name(prefs.keys[KEY_FALL1]));

        gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup_widget(prop,"level")),
                                  prefs.startinglevel);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup_widget(prop,"computerskills")),
                                  prefs.computerskills);
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"itemset")),prefs.items);
        gtk_entry_set_text(GTK_ENTRY(lookup_widget(prop,"background")),prefs.background);        

        for(;1==i;){
                i = gnome_dialog_run(GNOME_DIALOG(prop));
                if(0==i || 1==i){
                        /*
                         * grab the values...
                         */
                        gchar*bg = gtk_editable_get_chars(
                                GTK_EDITABLE(lookup_widget(prop,"background")),0,-1);
                        gchar*it = gtk_editable_get_chars(
                                GTK_EDITABLE(lookup_widget(prop,"itemset")),0,-1);

                        memcpy(&prefs,&prefscopy,sizeof prefs);

                        if(NULL==prefs.items || strcmp(it,prefs.items)){
                                g_free(prefs.items);
                                prefs.items = it;
                                reloadimages = TRUE;
                        }else 
                                g_free(it);
                        
                        if(NULL==prefs.background || strcmp(bg,prefs.background)){
                                g_free(prefs.background);
                                prefs.background = bg;
                                reloadimages = TRUE;
                        }else
                                g_free(bg);
                        
                        prefs.startinglevel = gtk_spin_button_get_value_as_int(
                                GTK_SPIN_BUTTON(lookup_widget(prop,"level")));
                        prefs.computerskills = gtk_spin_button_get_value_as_int(
                                GTK_SPIN_BUTTON(lookup_widget(prop,"computerskills")));
                        
                        save_settings();
                }
        }
        gnome_dialog_close(GNOME_DIALOG(prop));
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        GtkWidget*about = create_about();
        gtk_widget_show(about);
}


void
on_app_destroy                         (GtkObject       *object,
                                        gpointer         user_data)
{
 	gtk_main_quit();
}


gboolean
on_app_delete_event                    (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

 	gtk_main_quit();
	return TRUE;
}


gboolean
on_key_press_event                     (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
        if(prefs.keys[KEY_LEFT0]==event->keyval){
                game_move(0,left);
        }
        else if(prefs.keys[KEY_LEFT1]==event->keyval){
                game_move(1,left);
        }
        else if(prefs.keys[KEY_RIGHT0]==event->keyval){
                game_move(0,right);
        }
        else if(prefs.keys[KEY_RIGHT1]==event->keyval){
                game_move(1,right);
        }
        else if(prefs.keys[KEY_UP0]==event->keyval){
                game_move(0,up);
        }
        else if(prefs.keys[KEY_UP1]==event->keyval){
                game_move(1,up);
        }
        else if(prefs.keys[KEY_DOWN0]==event->keyval){
                game_move(0,down);
        }
        else if(prefs.keys[KEY_DOWN1]==event->keyval){
                game_move(1,down);
        }
        else if(prefs.keys[KEY_FALL0]==event->keyval){
                game_set_fast(0);
        }
        else if(prefs.keys[KEY_FALL1]==event->keyval){
                game_set_fast(1);
        }
/*        else if('l'==event->keyval)
                game_move(1,hint);
        else if('s'==event->keyval)
                game_move(0,hint);
        
*/      
        
        return FALSE;
}


gboolean
on_key_release_event                   (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
        return FALSE;
}


void
on_stop_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
}


gboolean
on_grab_key                            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
        int key = (int)user_data;
        if(key & 0x10000){
                key-= 0x10000;
                key+= 5;
        }
        prefscopy.keys[key] = event->keyval;
        gtk_entry_set_text(GTK_ENTRY(widget),gdk_keyval_name(event->keyval));
        return TRUE;
}

void
on_two_players_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_deadmatch();
}


void
on_left_player_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_left();
}


void
on_right_player_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_right();
}


void
on_200_contest_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_200_right();
}


void
on_score_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        gnome_scores_display(_("Gewels"),"gewels",NULL,0);
}

void
on_200_left_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_200_left();
}


void
on_computer_vs_human_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_comp_vs_human();
}


void
on_human_vs_computer_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_human_vs_comp();
}


void
on_computer_vs_computer_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        game_new_comp_vs_comp();
}


void
on_scores_normal_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
        gnome_scores_display(_("Gewels"),"gewels","1",0);
}

