#include "images.h"
#include "settings.h"
#include "support.h"

#include <math.h>

#define ITEM_STATES 6

extern int itemsize;
extern GtkWidget*app;

new_item paint_item = new_item_rect;
GdkImlibImage*numbersimages[10];  // 20x35
GdkImlibImage*itemimages[COLOR_COUNT][ITEM_STATES];
GdkImlibImage*backgroundimage;
char*getcolorname(int color);

GnomeAnimator*faceleft = NULL;
GnomeAnimator*faceright = NULL;

void resize_canvases(int is);

void resize_canvases(int is)
{
        int mainx = is*SIZE_X;
        int mainy = is*(SIZE_Y-3);
        int prex = is;
        int prey = is*3;
        GnomeCanvas*c;

        c = (GnomeCanvas*)lookup_widget(app,"field");
        gtk_widget_set_usize (GTK_WIDGET(c),mainx,mainy);
        gnome_canvas_set_scroll_region (c,0,0,mainx,mainy);
        c = (GnomeCanvas*)lookup_widget(app,"field2");
        gtk_widget_set_usize (GTK_WIDGET(c),mainx,mainy);
        gnome_canvas_set_scroll_region (c,0,0,mainx,mainy);
        c = (GnomeCanvas*)lookup_widget(app,"preview");
        gtk_widget_set_usize (GTK_WIDGET(c),prex,prey);
        gnome_canvas_set_scroll_region (c,0,0,prex,prey);
        c = (GnomeCanvas*)lookup_widget(app,"preview2");
        gtk_widget_set_usize (GTK_WIDGET(c),prex,prey);
        gnome_canvas_set_scroll_region (c,0,0,prex,prey);
}

void init_numbers(void)
{
        GdkImlibImage*image;
        gchar*it;

        it = gnome_unconditional_pixmap_file("gewels/numbers.png");

        image = gdk_imlib_load_image(it);
        g_free(it);
        
        if(NULL!=image){
                int i;
                for(i = 0;i<10;i++)
                        numbersimages[i] = gdk_imlib_crop_and_clone_image(image,i*20,0,20,35);
                gdk_imlib_destroy_image(image);
        }
}
void init_images(void)
{
        GdkImlibImage*image;
        gchar itname[100];
        gchar*it;

        strcpy(itname,"gewels/");
        strcat(itname,prefs.items);
        strcat(itname,".png");
        it = gnome_unconditional_pixmap_file(itname);

        image = gdk_imlib_load_image(it);
        g_free(it);
        
        backgroundimage = gdk_imlib_load_image(prefs.background);
        if(NULL!=image){
                int i,j;
                itemsize = image->rgb_height/6;
                resize_canvases(itemsize);
                paint_item = new_item_image;
                for(i = 0;i<COLOR_COUNT;i++)
                        for(j = 0;j<ITEM_STATES;j++){
                                itemimages[i][j] = gdk_imlib_crop_and_clone_image(
                                        image,i*itemsize,j*itemsize,
                                        itemsize,itemsize);
                        }
                gdk_imlib_destroy_image(image);
        } else {
                int i,j;
                for(i = 0;i<COLOR_COUNT;i++)
                        for(j = 0;j<ITEM_STATES;j++)
                                itemimages[i][j] = NULL;
                paint_item = new_item_rect;
        }
        reloadimages = FALSE;
}

void reload_images(void )
{
        if(reloadimages){
                free_images();
                init_images();
        }
}

void free_images(void)
{
        int i,j;
        for(i = 0;i<COLOR_COUNT;i++)
                for(j = 0;j<ITEM_STATES;j++)
                        if(NULL!=itemimages[i][j])
                                gdk_imlib_destroy_image(itemimages[i][j]);
        if(NULL!=backgroundimage)
                gdk_imlib_destroy_image(backgroundimage);
}
void free_numbers(void)
{
        int i;
        for (i = 0;i<10;i++)
                if(NULL!=numbersimages[i])
                        gdk_imlib_destroy_image(numbersimages[i]);
}
GnomeCanvasItem*new_background(GnomeCanvasGroup*parent,int x,int y)
{
        if(NULL==backgroundimage)
                return gnome_canvas_item_new(
                        parent,
                        gnome_canvas_rect_get_type(),
                        "x1", (double) 0,
                        "y1", (double) 0,
                        "x2", (double) SIZE_X*itemsize-1,
                        "y2", (double) (SIZE_Y-3)*itemsize-1,
                        "fill_color", "black",
                        "outline_color", "black",
                        "width_units", 1.0,
                        NULL);
        return gnome_canvas_item_new(
                parent,
                gnome_canvas_image_get_type(),
                "image",backgroundimage,
                "x", (double) 0,
                "y", (double) 0,
                "width", (double) x,
                "height", (double) y,
                "anchor", GTK_ANCHOR_NW,
                NULL);
}

FlashPointItem*new_score_flash(GnomeCanvasGroup*parent,int score)
{
        FlashPointItem*p = NULL;
        FlashPointItem*list = NULL;
        int s = score;
        int i = 0;
        while (s){
                s/= 10;
                i++;
        }
        i>>= 1;

        while(score){
                int digit = score%10;
                p = malloc(sizeof(FlashPointItem));
                score/= 10;
                p->item = gnome_canvas_item_new(
                        parent,
                        gnome_canvas_image_get_type(),
                        "image",numbersimages[digit],
                        "x", (double)(p->x = 20.0*i),
                        "y", (double) (p->y = 0),
                        "width", (double) 20,
                        "height", (double) 35,
                        "anchor", GTK_ANCHOR_NW,
                        NULL);
                p->next = list;
                list = p;
                i--;
        }
        return p;
}

GnomeCanvasItem*new_item_rect(GnomeCanvasGroup*parent,int x,int y,int color,int state)
{
        return gnome_canvas_item_new(
                parent,
                gnome_canvas_rect_get_type(),
                "x1", (double) x*itemsize,
                "y1", (double) (y-1)*itemsize-3*itemsize,
                "x2", (double) (x+1)*itemsize-1,
                "y2", (double) y*itemsize-1-3*itemsize,
                "fill_color", getcolorname(color),
                "outline_color", "white",
                "width_units", 1.0,
                NULL);
}

GnomeCanvasItem*new_item_image(GnomeCanvasGroup*parent,int x,int y,int color,int state)
{
        return gnome_canvas_item_new(
                parent,
                gnome_canvas_image_get_type(),
                "image",itemimages[color][state],
                "x", (double) x*itemsize,
                "y", (double) (y-1)*itemsize-3*itemsize,
                "width", (double) itemsize,
                "height", (double) itemsize,
                "anchor", GTK_ANCHOR_NW,
                NULL);
}
void load_faces(void )
{
        gchar*it;

        faceleft = (GnomeAnimator*)lookup_widget(app,"faceleft");
        faceright = (GnomeAnimator*)lookup_widget(app,"faceright");

        it = gnome_unconditional_pixmap_file("gewels/faces.png");

        gnome_animator_append_frames_from_file(faceleft,it,0,0,1000,40);
        gnome_animator_append_frames_from_file(faceright,it,0,0,1000,40);
}
void set_faces(int dm,int index)
{
        GnomeAnimator*my;
        GnomeAnimator*theother;
        int face = abs(dm)/(DEADMATCH/FACECOUNT);
        
        if(!index)
                return ;
        if(dm<0){
                my = faceleft;
                theother = faceright;
        }else{
                my = faceright;
                theother = faceleft;
        }
        gnome_animator_goto_frame(my,0);
        gnome_animator_goto_frame(theother,face>=FACECOUNT ? FACECOUNT-1 : face);
}

