#ifndef __SETTINGS_H__
#define __SETTINGS_H__

#include <gnome.h>

//
// size of item 
//
extern int itemsize;

//
// size of field (in items)
// size of field in pixels is itemsize*SIZE_X x itemsize*SIZE_Y
//
#define SIZE_X  6
#define SIZE_Y  15

// How many jewels must be the difference when penalty falls?
#define DEADMATCH 10
// Number of frames for face animation.
#define FACECOUNT 5

//
// count of item types
//
#define COLOR_COUNT  6
//#define COLOR_COUNT  1

#define JEWELS_IN_ONE_LEVEL 30
#define LEVEL_COUNT 50

#define KEY_LEFT0    0
#define KEY_RIGHT0   1
#define KEY_UP0      2
#define KEY_DOWN0    3
#define KEY_FALL0    4
#define KEY_LEFT1    5
#define KEY_RIGHT1   6
#define KEY_UP1      7
#define KEY_DOWN1    8
#define KEY_FALL1    9

typedef struct
{
        guint keys[10];
        gint startinglevel;
        gint computerskills;

        gchar*background;  // path+name of the bg image
        gchar*items;       // name itemset
}Preferences;

extern Preferences prefs;
extern gboolean reloadimages;  // if true images should be reloaded

void load_settings(void );
void save_settings(void );
void free_settings(void );

#endif//__SETTINGS_H__
